library plugin1;

{$mode objfpc}{$H+}

uses
  Classes
  { you can add units after this }, uPluginDefinition;

type

  { TPlugin1 }

  TPlugin1 = class(TInterfacedObject, IPlugin)
  private
    TheApp : IApplication;
  public
    function GetName() : String; stdcall;
    procedure SetApplication(aApp: IApplication); stdcall;
  end;

{ TPlugin1 }

function TPlugin1.GetName(): String; stdcall;
begin
   Result := 'Plugin1';
end;

procedure TPlugin1.SetApplication(aApp: IApplication); stdcall;
begin
   TheApp := aApp;

   TheApp.GetLabelX.Caption:=GetName();
end;

function LoadPlugin(out targetPlugin: IPlugin) : Boolean; stdcall; export;
begin
   try
     targetPlugin := TPlugin1.Create();
     Result := True;
   except
     Result := False;
   end;
end;


exports
  LoadPlugin name 'LoadPlugin';

{$IFDEF WINDOWS}{$R plugin1.rc}{$ENDIF}

begin
end.

